Index: drivers/filesystems/btrfs/extent-tree.c
===================================================================
--- drivers/filesystems/btrfs/extent-tree.c	(révision 75772)
+++ drivers/filesystems/btrfs/extent-tree.c	(copie de travail)
@@ -1737,20 +1894,20 @@
         ei->flags = flags;
         return;
     }
-    
+
     if (tp.item->key.obj_id != address || tp.item->key.obj_type != TYPE_EXTENT_ITEM) {
         ERR("couldn't find %llx in extent tree\n", address);
         return;
     }
-    
+
     if (tp.item->size == sizeof(EXTENT_ITEM_V0))
         return;
     else if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %x bytes, expected at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type,
-                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_DATA));
+                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
     ei->flags = flags;
 }
@@ -1758,23 +1915,23 @@
 static changed_extent* get_changed_extent_item(chunk* c, UINT64 address, UINT64 size, BOOL no_csum) {
     LIST_ENTRY* le;
     changed_extent* ce;
-    
+
     le = c->changed_extents.Flink;
     while (le != &c->changed_extents) {
         ce = CONTAINING_RECORD(le, changed_extent, list_entry);
-        
+
         if (ce->address == address && ce->size == size)
             return ce;
-        
+
         le = le->Flink;
     }
-    
+
     ce = ExAllocatePoolWithTag(PagedPool, sizeof(changed_extent), ALLOC_TAG);
     if (!ce) {
         ERR("out of memory\n");
         return NULL;
     }
-    
+
     ce->address = address;
     ce->size = size;
     ce->old_size = size;
@@ -1784,13 +1941,13 @@
     ce->superseded = FALSE;
     InitializeListHead(&ce->refs);
     InitializeListHead(&ce->old_refs);
-    
+
     InsertTailList(&c->changed_extents, &ce->list_entry);
-    
+
     return ce;
 }
 
-NTSTATUS update_changed_extent_ref(device_extension* Vcb, chunk* c, UINT64 address, UINT64 size, UINT64 root, UINT64 objid, UINT64 offset, signed long long count,
+NTSTATUS update_changed_extent_ref(device_extension* Vcb, chunk* c, UINT64 address, UINT64 size, UINT64 root, UINT64 objid, UINT64 offset, INT32 count,
                                    BOOL no_csum, BOOL superseded, PIRP Irp) {
     LIST_ENTRY* le;
     changed_extent* ce;
@@ -1798,48 +1955,48 @@
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
-    UINT64 old_count;
-    
+    UINT32 old_count;
+
     ExAcquireResourceExclusiveLite(&c->changed_extents_lock, TRUE);
-    
+
     ce = get_changed_extent_item(c, address, size, no_csum);
-    
+
     if (!ce) {
         ERR("get_changed_extent_item failed\n");
         Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
     if (IsListEmpty(&ce->refs) && IsListEmpty(&ce->old_refs)) { // new entry
         searchkey.obj_id = address;
         searchkey.obj_type = TYPE_EXTENT_ITEM;
         searchkey.offset = 0xffffffffffffffff;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             goto end;
         }
-        
+
         if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
             ERR("could not find address %llx in extent tree\n", address);
             Status = STATUS_INTERNAL_ERROR;
             goto end;
         }
-        
+
         if (tp.item->key.offset != size) {
             ERR("extent %llx had size %llx, not %llx as expected\n", address, tp.item->key.offset, size);
             Status = STATUS_INTERNAL_ERROR;
             goto end;
         }
-        
+
         if (tp.item->size == sizeof(EXTENT_ITEM_V0)) {
             EXTENT_ITEM_V0* eiv0 = (EXTENT_ITEM_V0*)tp.item->data;
-            
+
             ce->count = ce->old_count = eiv0->refcount;
         } else if (tp.item->size >= sizeof(EXTENT_ITEM)) {
             EXTENT_ITEM* ei = (EXTENT_ITEM*)tp.item->data;
-            
+
             ce->count = ce->old_count = ei->refcount;
         } else {
             ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
@@ -1847,71 +2004,71 @@
             goto end;
         }
     }
-    
+
     le = ce->refs.Flink;
     while (le != &ce->refs) {
         cer = CONTAINING_RECORD(le, changed_extent_ref, list_entry);
-        
+
         if (cer->type == TYPE_EXTENT_DATA_REF && cer->edr.root == root && cer->edr.objid == objid && cer->edr.offset == offset) {
             ce->count += count;
             cer->edr.count += count;
             Status = STATUS_SUCCESS;
-            
+
             if (superseded)
                 ce->superseded = TRUE;
-            
+
             goto end;
         }
-        
+
         le = le->Flink;
     }
-    
+
     old_count = find_extent_data_refcount(Vcb, address, size, root, objid, offset, Irp);
-    
+
     if (old_count > 0) {
         cer = ExAllocatePoolWithTag(PagedPool, sizeof(changed_extent_ref), ALLOC_TAG);
-    
+
         if (!cer) {
             ERR("out of memory\n");
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
+
         cer->type = TYPE_EXTENT_DATA_REF;
         cer->edr.root = root;
         cer->edr.objid = objid;
         cer->edr.offset = offset;
         cer->edr.count = old_count;
-        
+
         InsertTailList(&ce->old_refs, &cer->list_entry);
     }
-    
+
     cer = ExAllocatePoolWithTag(PagedPool, sizeof(changed_extent_ref), ALLOC_TAG);
-    
+
     if (!cer) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     cer->type = TYPE_EXTENT_DATA_REF;
     cer->edr.root = root;
     cer->edr.objid = objid;
     cer->edr.offset = offset;
     cer->edr.count = old_count + count;
-    
+
     InsertTailList(&ce->refs, &cer->list_entry);
-    
+
     ce->count += count;
-    
+
     if (superseded)
         ce->superseded = TRUE;
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(&c->changed_extents_lock);
-    
+
     return Status;
 }
 
@@ -1919,42 +2076,42 @@
     changed_extent* ce;
     changed_extent_ref* cer;
     LIST_ENTRY* le;
-    
+
     ce = get_changed_extent_item(c, address, size, no_csum);
-    
+
     if (!ce) {
         ERR("get_changed_extent_item failed\n");
         return;
     }
-    
+
     le = ce->refs.Flink;
     while (le != &ce->refs) {
         cer = CONTAINING_RECORD(le, changed_extent_ref, list_entry);
-        
+
         if (cer->type == TYPE_EXTENT_DATA_REF && cer->edr.root == root && cer->edr.objid == objid && cer->edr.offset == offset) {
             ce->count += count;
             cer->edr.count += count;
             return;
         }
-        
+
         le = le->Flink;
     }
-    
+
     cer = ExAllocatePoolWithTag(PagedPool, sizeof(changed_extent_ref), ALLOC_TAG);
-    
+
     if (!cer) {
         ERR("out of memory\n");
         return;
     }
-    
+
     cer->type = TYPE_EXTENT_DATA_REF;
     cer->edr.root = root;
     cer->edr.objid = objid;
     cer->edr.offset = offset;
     cer->edr.count = count;
-    
+
     InsertTailList(&ce->refs, &cer->list_entry);
-    
+
     ce->count += count;
 }
 
@@ -1966,38 +2123,38 @@
     EXTENT_ITEM* ei;
     UINT32 len;
     UINT8* ptr;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || (tp.item->key.obj_type != TYPE_EXTENT_ITEM && tp.item->key.obj_type != TYPE_METADATA_ITEM)) {
         TRACE("could not find address %llx in extent tree\n", address);
         return 0;
     }
-    
+
     if (tp.item->key.obj_type == TYPE_EXTENT_ITEM && tp.item->key.offset != Vcb->superblock.node_size) {
         ERR("extent %llx had size %llx, not %llx as expected\n", address, tp.item->key.offset, Vcb->superblock.node_size);
         return 0;
     }
-    
+
     if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx): size was %u, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return 0;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
     inline_rc = 0;
-    
+
     len = tp.item->size - sizeof(EXTENT_ITEM);
     ptr = (UINT8*)&ei[1];
-    
+
     if (searchkey.obj_type == TYPE_EXTENT_ITEM && ei->flags & EXTENT_ITEM_TREE_BLOCK) {
         if (tp.item->size < sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2)) {
             ERR("(%llx,%x,%llx): size was %u, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
@@ -2004,18 +2161,18 @@
                                                                        tp.item->size, sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2));
             return 0;
         }
-        
+
         len -= sizeof(EXTENT_ITEM2);
         ptr += sizeof(EXTENT_ITEM2);
     }
-    
+
     while (len > 0) {
         UINT8 secttype = *ptr;
         ULONG sectlen = get_extent_data_len(secttype);
         UINT64 sectcount = get_extent_data_refcount(secttype, ptr + sizeof(UINT8));
-        
+
         len--;
-        
+
         if (sectlen > len) {
             ERR("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, len, sectlen);
             return 0;
@@ -2025,45 +2182,41 @@
             ERR("(%llx,%x,%llx): unrecognized extent type %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, secttype);
             return 0;
         }
-        
+
         if (secttype == TYPE_SHARED_BLOCK_REF) {
             SHARED_BLOCK_REF* sectsbr = (SHARED_BLOCK_REF*)(ptr + sizeof(UINT8));
-            
+
             if (sectsbr->offset == parent)
                 return 1;
         }
-        
+
         len -= sectlen;
         ptr += sizeof(UINT8) + sectlen;
         inline_rc += sectcount;
     }
-    
+
     // FIXME - what if old?
-    
+
     if (inline_rc == ei->refcount)
         return 0;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_SHARED_BLOCK_REF;
     searchkey.offset = parent;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
-    if (!keycmp(searchkey, tp.item->key)) {    
-        if (tp.item->size < sizeof(SHARED_BLOCK_REF))
-            ERR("(%llx,%x,%llx) has size %u, not %u as expected\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(SHARED_BLOCK_REF));
-        else
-            return 1;
-    }
-    
+
+    if (!keycmp(searchkey, tp.item->key))
+        return 1;
+
     return 0;
 }
 
-UINT64 find_extent_shared_data_refcount(device_extension* Vcb, UINT64 address, UINT64 parent, PIRP Irp) {
+UINT32 find_extent_shared_data_refcount(device_extension* Vcb, UINT64 address, UINT64 parent, PIRP Irp) {
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
@@ -2071,40 +2224,40 @@
     EXTENT_ITEM* ei;
     UINT32 len;
     UINT8* ptr;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || (tp.item->key.obj_type != TYPE_EXTENT_ITEM && tp.item->key.obj_type != TYPE_METADATA_ITEM)) {
         TRACE("could not find address %llx in extent tree\n", address);
         return 0;
     }
-    
+
     if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx): size was %u, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return 0;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
     inline_rc = 0;
-    
+
     len = tp.item->size - sizeof(EXTENT_ITEM);
     ptr = (UINT8*)&ei[1];
-    
+
     while (len > 0) {
         UINT8 secttype = *ptr;
         ULONG sectlen = get_extent_data_len(secttype);
         UINT64 sectcount = get_extent_data_refcount(secttype, ptr + sizeof(UINT8));
-        
+
         len--;
-        
+
         if (sectlen > len) {
             ERR("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, len, sectlen);
             return 0;
@@ -2114,42 +2267,42 @@
             ERR("(%llx,%x,%llx): unrecognized extent type %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, secttype);
             return 0;
         }
-        
+
         if (secttype == TYPE_SHARED_DATA_REF) {
             SHARED_DATA_REF* sectsdr = (SHARED_DATA_REF*)(ptr + sizeof(UINT8));
-            
+
             if (sectsdr->offset == parent)
                 return sectsdr->count;
         }
-        
+
         len -= sectlen;
         ptr += sizeof(UINT8) + sectlen;
         inline_rc += sectcount;
     }
-    
+
     // FIXME - what if old?
-    
+
     if (inline_rc == ei->refcount)
         return 0;
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_SHARED_DATA_REF;
     searchkey.offset = parent;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return 0;
     }
-    
-    if (!keycmp(searchkey, tp.item->key)) {    
-        if (tp.item->size < sizeof(SHARED_DATA_REF))
-            ERR("(%llx,%x,%llx) has size %u, not %u as expected\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(SHARED_DATA_REF));
+
+    if (!keycmp(searchkey, tp.item->key)) {
+        if (tp.item->size < sizeof(UINT32))
+            ERR("(%llx,%x,%llx) has size %u, not %u as expected\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(UINT32));
         else {
-            SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)tp.item->data;
-            return sdr->count;
+            UINT32* count = (UINT32*)tp.item->data;
+            return *count;
         }
     }
-    
+
     return 0;
 }
